import gurobipy as gp
from gurobipy import GRB 
import pandas as pd

def floyd_warshall(dist_matrix):
    n = len(dist_matrix)
    # Initialisiere die Matrix für die kürzesten Wege
    shortest_paths = [[float('inf')] * n for _ in range(n)]
    
    # Setze die Diagonale auf 0 (kürzester Weg von einem Knoten zu sich selbst ist 0)
    for i in range(n):
        shortest_paths[i][i] = 0
    
    # Kopiere die Werte der Distanzmatrix in die Matrix für die kürzesten Wege
    for i in range(n):
        for j in range(n):
            shortest_paths[i][j] = dist_matrix[i][j]
    
    # Berechne die kürzesten Wege zwischen allen Knoten
    for k in range(n):
        for i in range(n):
            for j in range(n):
                shortest_paths[i][j] = min(shortest_paths[i][j], shortest_paths[i][k] + shortest_paths[k][j])
    
    return shortest_paths

def triple_algorithm(dist_matrix):
    n = len(dist_matrix)
    
    for i in range(n):
        for j in range(n):
            for k in range(n):
                if dist_matrix[i][j] > dist_matrix[i][k] + dist_matrix[k][j]:
                    return False  # Dreiecksungleichung verletzt
    
    return True

def bester_nachfolger(distances_input):
    num_nodes = len(distances_input)
    tour=[]
    tour.append(0)
    distance=0

    #for i in range(num_nodes):
        #distances_input[i][i]=1000000

    while(len(tour)<num_nodes):
        min=1000000
        for j in range(num_nodes):
            if distances_input[tour[-1]][j]<min and j not in tour:
                min=distances_input[tour[-1]][j]
                current=j
        distance+=distances_input[tour[-1]][current]
        tour.append(current)
    distance+=distances_input[tour[-1]][0]
    tour.append(0)

    for j in range(num_nodes+1):
        tour[j]=tour[j]+1
    
    return tour, distance

