import numpy as np
import pandas as pd

def floyd_algorithm(cost_matrix):

    n = len(cost_matrix)
    shortest_path_matrix = [[0] * n for _ in range(n)]

    for i in range(n):
        for j in range(n):
            shortest_path_matrix[i][j] = cost_matrix[i][j]

    for k in range(n):
        for i in range(n):
            for j in range(n):
                if i!=j:
                    shortest_path_matrix[i][j] = min(shortest_path_matrix[i][j], shortest_path_matrix[i][k] + shortest_path_matrix[k][j])
                else:
                    shortest_path_matrix[i][j] = np.inf

    return shortest_path_matrix

def initialization(cost_matrix, tour):
    max=-np.inf
    pos=tuple()
    for idx, list in enumerate(cost_matrix):
        for idx1, list_value in enumerate(list):
            if list_value>max and list_value<np.inf:
                pos=(idx,idx1)
                max=list_value
    tour.extend([pos[0],pos[1],pos[0]])
    return tour



def min_max_determination(tour, cost_matrix):
    missing=[i for i in range(len(cost_matrix)) if i not in tour]
    dict_min_max=dict()
    pos=-1
    node=-1
    for i in missing:
        min=np.inf
        for idx, j in enumerate(tour):
            if cost_matrix[i][j]<min:
                min=cost_matrix[i][j]
                pos=idx
                node=j
        dict_min_max[i]=(min,pos,node)

    
    max=-np.inf
    max_key=-10000
    for key, val in dict_min_max.items():
        if val[0]>max:
            max=val[0]
            max_key=key


    min_dist_pos=-1
    min_delta=np.inf
    for i in range(len(tour)-1):
        current=cost_matrix[tour[i]][max_key]+cost_matrix[max_key][tour[i+1]]-cost_matrix[tour[i]][tour[i+1]]
        if current<min_delta:
            min_delta=current
            min_dist_pos=i+1

    tour.insert(min_dist_pos, max_key)
    return tour

def sukzessive_einbeziehung(distances):
    cost_matrix=distances
    tour=[]
    tour=initialization(cost_matrix,tour)         
    while len(tour) != len(cost_matrix)+1:    
        tour=min_max_determination(tour,cost_matrix)

    costs=0
    for i in range(len(tour)-1):
        costs+=cost_matrix[tour[i]][tour[i+1]]

    for i in range(len(tour)):
        tour[i]+=1
        
    return tour, costs
